## ctre 3.9.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.29.20240416") 
	set(CMAKE_EXPERIMENTAL_CXX_IMPORT_STD "0e5b6991-d74f-4b3d-a41c-cf096e0b2508")
	set(CMAKE_CXX_MODULE_STD 1)
endif()

# When updating to a newer version of CMake, see if we can use the following
project(ctre
  HOMEPAGE_URL "https://compile-time.re"
  VERSION 3.9.0
  LANGUAGES CXX)
set(PROJECT_DESCRIPTION "Fast compile-time regular expressions with support for matching/searching/capturing during compile-time or runtime.")

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(CTest)

find_program(CTRE_DPKG_BUILDPACKAGE_FOUND dpkg-buildpackage)
find_program(CTRE_RPMBUILD_FOUND rpmbuild)

cmake_dependent_option(CTRE_BUILD_TESTS "Build ctre Tests" ON
  "BUILD_TESTING;CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)
cmake_dependent_option(CTRE_BUILD_PACKAGE "Build ctre Packages" ON
  "CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)
cmake_dependent_option(CTRE_BUILD_PACKAGE_DEB
  "Create DEB Package (${PROJECT_NAME})" ON
  "CTRE_BUILD_PACKAGE;CTRE_DPKG_BUILDPACKAGE_FOUND" OFF)
cmake_dependent_option(CTRE_BUILD_PACKAGE_RPM
  "Create RPM Package (${PROJECT_NAME})" ON
  "CTRE_BUILD_PACKAGE;CTRE_RPMBUILD_FOUND" OFF)

option(CTRE_MODULE "build C++ module" OFF)

if(CTRE_MODULE)
	if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.29.20240416") 
		add_library(${PROJECT_NAME})
		
		target_sources(${PROJECT_NAME} PUBLIC FILE_SET CXX_MODULES TYPE CXX_MODULES FILES ctre.cppm)
		target_sources(${PROJECT_NAME} PUBLIC FILE_SET HEADERS TYPE HEADERS FILES 
			include/ctll.hpp
			include/ctre/functions.hpp
			include/ctre/utility.hpp
			include/ctre/utf8.hpp
			include/ctre/evaluation.hpp
			include/ctre/starts_with_anchor.hpp
			include/ctre/pcre_actions.hpp
			include/ctre/rotate.hpp
			include/ctre/iterators.hpp
			include/ctre/literals.hpp
			include/ctre/return_type.hpp
			include/ctre/find_captures.hpp
			include/ctre/id.hpp
			include/ctre/atoms_characters.hpp
			include/ctre/actions/mode.inc.hpp
			include/ctre/actions/characters.inc.hpp
			include/ctre/actions/class.inc.hpp
			include/ctre/actions/look.inc.hpp
			include/ctre/actions/sequence.inc.hpp
			include/ctre/actions/fusion.inc.hpp
			include/ctre/actions/asserts.inc.hpp
			include/ctre/actions/capture.inc.hpp
			include/ctre/actions/named_class.inc.hpp
			include/ctre/actions/backreference.inc.hpp
			include/ctre/actions/options.inc.hpp
			include/ctre/actions/atomic_group.inc.hpp
			include/ctre/actions/set.inc.hpp
			include/ctre/actions/hexdec.inc.hpp
			include/ctre/actions/repeat.inc.hpp
			include/ctre/actions/properties.inc.hpp
			include/ctre/actions/boundaries.inc.hpp
			include/ctre/operators.hpp
			include/ctre/pcre.hpp
			include/ctre/atoms_unicode.hpp
			include/ctre/range.hpp
			include/ctre/wrapper.hpp
			include/ctre/first.hpp
			include/ctre/flags_and_modes.hpp
			include/ctre/atoms.hpp
			include/unicode-db.hpp
			include/unicode-db/unicode_interface.hpp
			include/unicode-db/unicode-db.hpp
			include/ctll/parser.hpp
			include/ctll/actions.hpp
			include/ctll/fixed_string.hpp
			include/ctll/list.hpp
			include/ctll/utilities.hpp
			include/ctll/grammars.hpp
			include/ctre.hpp
			include/ctre-unicode.hpp
		)
		
		# we are using `import std;`
		if (CTRE_CXX_STANDARD LESS 23)
			set(CTRE_CXX_STANDARD 23)
		endif()

		target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
		target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_${CTRE_CXX_STANDARD})
	else()
		message(FATAL_ERROR "unsupported cmake for c++ modules")
	endif()
else()
	add_library(${PROJECT_NAME} INTERFACE)
	
	target_include_directories(${PROJECT_NAME} INTERFACE
	  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	  $<INSTALL_INTERFACE:include>)

	if (NOT CTRE_CXX_STANDARD)
	  set(CTRE_CXX_STANDARD 20)
	endif()

	target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_${CTRE_CXX_STANDARD})
	
	install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}-targets)
endif()

add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if (NOT CTRE_MODULE)

if (NOT EXISTS "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in")
  file(WRITE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in [[
    @PACKAGE_INIT@
    include("${CMAKE_CURRENT_LIST_DIR}/@PROJECT_NAME@-targets.cmake")
  ]])
endif()

configure_package_config_file(
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}"
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(ctre-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion)

install(EXPORT ${PROJECT_NAME}-targets 
  DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}"
  NAMESPACE ${PROJECT_NAME}::)
install(
  FILES
    "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
    "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  DESTINATION ${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME})
install(DIRECTORY include/ DESTINATION include
    FILES_MATCHING PATTERN *.hpp)

if(CTRE_BUILD_TESTS)
  add_subdirectory(tests)
endif()

if (NOT CTRE_BUILD_PACKAGE)
  return()
endif()

list(APPEND source-generators TBZ2 TGZ TXZ ZIP)

if (CTRE_BUILD_PACKAGE_DEB)
  list(APPEND binary-generators "DEB")
endif()

if (CTRE_BUILD_PACKAGE_RPM)
  list(APPEND binary-generators "RPM")
endif()

set(CPACK_SOURCE_GENERATOR ${source-generators})
set(CPACK_GENERATOR ${binary-generators})

set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}")

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Hana Dusíková")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "${PROJECT_DESCRIPTION}")
set(CPACK_DEBIAN_PACKAGE_NAME "lib${PROJECT_NAME}-dev")

set(CPACK_RPM_PACKAGE_NAME "lib${PROJECT_NAME}-devel")

set(PKG_CONFIG_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/packaging/pkgconfig.pc.in" "${PKG_CONFIG_FILE_NAME}" @ONLY)
install(FILES "${PKG_CONFIG_FILE_NAME}"
	DESTINATION "${CMAKE_INSTALL_DATADIR}/pkgconfig"
)

list(APPEND CPACK_SOURCE_IGNORE_FILES /.git/ /build/ .gitignore .DS_Store)

include(CPack)

endif()

=== Makefile ===
.PHONY: default all clean grammar compare single-header single-header/ctre.hpp single-header/ctre-unicode.hpp single-header/unicode-db.hpp

default: all
	
TARGETS := $(wildcard tests/benchmark-exec/*.cpp)
IGNORE := $(wildcard tests/benchmark/*.cpp) $(wildcard tests/benchmark-exec/*.cpp)

DESATOMAT := /bin/false

CXX_STANDARD := 20

PYTHON := python3.9

PEDANTIC:=-pedantic

override CXXFLAGS := $(CXXFLAGS) -std=c++$(CXX_STANDARD) -Iinclude -O3 $(PEDANTIC) -Wall -Wextra -Werror -Wconversion
LDFLAGS := 

TESTS := $(wildcard tests/*.cpp) $(wildcard tests/benchmark/*.cpp)
TRUE_TARGETS := $(TARGETS:%.cpp=%)
override TRUE_TARGETS := $(filter-out $(IGNORE:%.cpp=%), $(TRUE_TARGETS))
OBJECTS := $(TARGETS:%.cpp=%.o) $(TESTS:%.cpp=%.o)
override OBJECTS := $(filter-out $(IGNORE:%.cpp=%.o),$(OBJECTS))
DEPEDENCY_FILES := $(OBJECTS:%.o=%.d)

all: $(TRUE_TARGETS) $(OBJECTS)
	
list:
	echo $(SUPPORTED_CPP20)
	
$(TRUE_TARGETS): %: %.o
	$(CXX)  $< $(LDFLAGS) -o $@ 
	
$(OBJECTS): %.o: %.cpp
	$(CXX) $(CXXFLAGS) -MMD -c $< -o $@

-include $(DEPEDENCY_FILES)

benchmark:
	@$(MAKE) clean
	@$(MAKE) IGNORE=""
	
benchmark-clean:
	@$(MAKE) IGNORE="" clean

clean:
	rm -f $(TRUE_TARGETS) $(OBJECTS) $(DEPEDENCY_FILES) mtent12.txt mtent12.zip
	
grammar: include/ctre/pcre.hpp
	
regrammar: 
	@rm -f include/ctre/pcre.hpp
	@$(MAKE) grammar
	
include/ctre/pcre.hpp: include/ctre/pcre.gram
	@echo "LL1q $<"
	@$(DESATOMAT) --ll --q --input=include/ctre/pcre.gram --output=include/ctre/ --generator=cpp_ctll_v2  --cfg:fname=pcre.hpp --cfg:namespace=ctre --cfg:guard=CTRE__PCRE__HPP --cfg:grammar_name=pcre
	
mtent12.zip:
	curl -s http://www.gutenberg.org/files/3200/old/mtent12.zip -o mtent12.zip
	
mtent12.txt: mtent12.zip
	unzip -o mtent12.zip
	touch mtent12.txt

single-header: single-header/ctre.hpp single-header/ctre-unicode.hpp single-header/unicode-db.hpp

single-header/unicode-db.hpp: include/unicode-db/unicode-db.hpp
	cp $+ $@

single-header/ctre.hpp:
	${PYTHON} -m quom include/ctre.hpp ctre.hpp.tmp
	echo "/*" > single-header/ctre.hpp
	cat LICENSE >> single-header/ctre.hpp
	echo "*/" >> single-header/ctre.hpp
	cat ctre.hpp.tmp >> single-header/ctre.hpp
	rm ctre.hpp.tmp

single-header/ctre-unicode.hpp:
	${PYTHON} -m quom include/ctre-unicode.hpp ctre-unicode.hpp.tmp
	echo "/*" > single-header/ctre-unicode.hpp
	cat LICENSE >> single-header/ctre-unicode.hpp
	echo "*/" >> single-header/ctre-unicode.hpp
	cat ctre-unicode.hpp.tmp >> single-header/ctre-unicode.hpp
	rm ctre-unicode.hpp.tmp
	
REPEAT:=10

compare: mtent12.txt
	$(CXX) $(CXXFLAGS) -MMD -march=native -DPATTERN="\"(${PATTERN})\"" -c tests/benchmark-range/measurement.cpp -o tests/benchmark-range/measurement.o
	$(CXX) tests/benchmark-range/measurement.o -lboost_regex -lpcre2-8 -lre2 -o tests/benchmark-range/measurement
	tests/benchmark-range/measurement all mtent12.txt ${REPEAT}

=== debian/changelog ===
ctre (3.9.0+ds-2) unstable; urgency=medium

  * Source-only upload to allow migration.
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + do not build libctre-doc under profile nodoc.

 -- Shengqi Chen <harry@debian.org>  Sun, 09 Mar 2025 17:28:14 +0800

ctre (3.9.0+ds-1) unstable; urgency=medium

  * Initial packaging for ctre 3.9.0+ds (closes: #1095833).

 -- Shengqi Chen <harry@debian.org>  Tue, 25 Feb 2025 15:44:21 +0800

=== debian/control ===
Source: ctre
Section: utils
Priority: optional
Standards-Version: 4.7.2
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
Homepage: https://github.com/hanickadot/compile-time-regular-expressions
Vcs-Git: https://salsa.debian.org/harry/ctre.git
Vcs-Browser: https://salsa.debian.org/harry/ctre
Rules-Requires-Root: no

Package: libctre-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: Compile Time Regular Expression library in C++ (development files)
 ctre is a fast compile-time regular expressions C++ library with support
 for matching/searching/capturing during compile-time or runtime.
 .
 This package contains the development files of libctre.

Package: libctre-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Compile Time Regular Expression library in C++ (documentation)
 ctre is a fast compile-time regular expressions C++ library with support
 for matching/searching/capturing during compile-time or runtime.
 .
 This package contains the documentation of libctre.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

DOC_INSTALL_DIR = debian/libctre-doc/usr/share/doc/libctre-dev

%:
	dh $@ --with=sphinxdoc --buildsystem=cmake+ninja --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- -DCTRE_BUILD_TESTS=ON

override_dh_installdocs:
	dh_installdocs
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	touch "$(CURDIR)/docs/_static" # referred to in docs/conf.py, avoid errors
	sphinx-build -N -bhtml "$(CURDIR)/docs" "$(DOC_INSTALL_DIR)/html/"
	rm "$(DOC_INSTALL_DIR)/html/_static/_static" # make lintian happy
endif

override_dh_auto_test:
# these test files only need to be built, not run
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cmake --build build --target ctre-test --verbose
endif

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g,\
  filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/hanickadot/compile-time-regular-expressions/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## ctre 3.10.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
 Package: libctre-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Compile Time Regular Expression library in C++ (development files)
  ctre is a fast compile-time regular expressions C++ library with support
@@ -28,6 +29,7 @@
 Build-Profiles: <!nodoc>
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: Compile Time Regular Expression library in C++ (documentation)
  ctre is a fast compile-time regular expressions C++ library with support

## ctre 3.10.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.14.0)
+cmake_minimum_required(VERSION 3.14...3.29)
 
 if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.29.20240416") 
 	set(CMAKE_EXPERIMENTAL_CXX_IMPORT_STD "0e5b6991-d74f-4b3d-a41c-cf096e0b2508")
@@ -38,7 +38,10 @@
 		add_library(${PROJECT_NAME})
 		
 		target_sources(${PROJECT_NAME} PUBLIC FILE_SET CXX_MODULES TYPE CXX_MODULES FILES ctre.cppm)
-		target_sources(${PROJECT_NAME} PUBLIC FILE_SET HEADERS TYPE HEADERS FILES 
+		target_sources(${PROJECT_NAME} PUBLIC FILE_SET HEADERS TYPE HEADERS
+		    BASE_DIRS
+			"${CMAKE_CURRENT_SOURCE_DIR}/include"
+		    FILES 
 			include/ctll.hpp
 			include/ctre/functions.hpp
 			include/ctre/utility.hpp
@@ -92,12 +95,15 @@
 		)
 		
 		# we are using `import std;`
-		if (CTRE_CXX_STANDARD LESS 23)
+		if (NOT DEFINED CTRE_CXX_STANDARD OR CTRE_CXX_STANDARD LESS 23)
 			set(CTRE_CXX_STANDARD 23)
 		endif()
 
-		target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
 		target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_${CTRE_CXX_STANDARD})
+
+		install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}-targets
+			FILE_SET CXX_MODULES DESTINATION "${CMAKE_INSTALL_LIBDIR}/cxx/${PROJECT_NAME}"
+			FILE_SET HEADERS DESTINATION "include")
 	else()
 		message(FATAL_ERROR "unsupported cmake for c++ modules")
 	endif()
@@ -113,13 +119,14 @@
 	endif()
 
 	target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_${CTRE_CXX_STANDARD})
+	set_property(TARGET ${PROJECT_NAME} PROPERTY CXX_SCAN_FOR_MODULES 0)
 	
 	install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}-targets)
+	install(DIRECTORY include/ DESTINATION include
+	    FILES_MATCHING PATTERN *.hpp)
 endif()
 
 add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
-
-if (NOT CTRE_MODULE)
 
 if (NOT EXISTS "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in")
   file(WRITE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in [[
@@ -131,7 +138,7 @@
 configure_package_config_file(
   "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake.in"
   "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
-  INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}"
+  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
   NO_SET_AND_CHECK_MACRO
   NO_CHECK_REQUIRED_COMPONENTS_MACRO)
 
@@ -140,15 +147,13 @@
   COMPATIBILITY SameMajorVersion)
 
 install(EXPORT ${PROJECT_NAME}-targets 
-  DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}"
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
   NAMESPACE ${PROJECT_NAME}::)
 install(
   FILES
     "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
     "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
-  DESTINATION ${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME})
-install(DIRECTORY include/ DESTINATION include
-    FILES_MATCHING PATTERN *.hpp)
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
 
 if(CTRE_BUILD_TESTS)
   add_subdirectory(tests)
@@ -183,11 +188,9 @@
 set(PKG_CONFIG_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc")
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/packaging/pkgconfig.pc.in" "${PKG_CONFIG_FILE_NAME}" @ONLY)
 install(FILES "${PKG_CONFIG_FILE_NAME}"
-	DESTINATION "${CMAKE_INSTALL_DATADIR}/pkgconfig"
+	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
 )
 
 list(APPEND CPACK_SOURCE_IGNORE_FILES /.git/ /build/ .gitignore .DS_Store)
 
 include(CPack)
-
-endif()

=== tests/benchmark-exec/Makefile ===
.PHONY: default all run clean header

PATTERN := ABCD|DEFGH|EFGHI|A{4,}
FILE := input.txt

PATTERN_HASH := $(shell echo "$(PATTERN)" | /sbin/md5)

LIBRARIES := $(sort baseline boost ctre pcre pcre-jit re2 std xpressive srell)

default: all

CXXFLAGS := -std=c++2a -I../../include -Isrell_include
LDFLAGS :=

ctre_CXXFLAGS := 
ctre_LDFLAGS := 
ctre_NAME := CTRE

boost_CXXFLAGS := 
boost_LDFLAGS := -lboost_regex
boost_NAME := boost::regex

pcre_CXXFLAGS :=
pcre_LDFLAGS := -lpcre2-8
pcre_NAME := PCRE2

pcre-jit_CXXFLAGS :=
pcre-jit_LDFLAGS := -lpcre2-8
pcre-jit_NAME := PCRE2 (jit)

re2_CXXFLAGS :=
re2_LDFLAGS := -lre2
re2_NAME := RE2

std_NAME := std::regex

xpressive_NAME := boost::xpressive

srell_NAME := srell

all: $(LIBRARIES)

$(PATTERN_HASH).tmp:
	@rm -f *.tmp
	@touch $@

pattern.hpp: $(PATTERN_HASH).tmp
	@echo "#define PATTERN \"$(PATTERN)\"" > pattern.hpp

$(LIBRARIES:%=%.o): %.o: %.cpp common.hpp $(PATTERN_HASH).tmp pattern.hpp
	$(CXX) -O3 $(CXXFLAGS) ${${@:%.o=%}_CXXFLAGS} -c $< -o $@

$(LIBRARIES): %: %.o common.hpp $(PATTERN_HASH).tmp pattern.hpp
	$(CXX) -O3 $(LDFLAGS) ${${@}_LDFLAGS} $< -o $@

header.csv:
	echo "library;pattern;duration" > header.csv
	echo "library;pattern;duration" > result.csv

$(LIBRARIES:%=%.run): %.run: % header
	./$< $(FILE) benchmark "${${<}_NAME}" 2>/dev/null >>result.csv

run: $(LIBRARIES:%=%.run)
	
node:
	node node-v8.js path=${FILE} pattern="${PATTERN}"

jsc:
	jsc jsc.js -- path=${FILE} pattern="${PATTERN}"

result.csv: header.csv $(LIBRARIES:%=%.run)
	touch result.csv

clean:
	rm -f $(LIBRARIES) *.tmp header.csv result.csv

=== debian/changelog ===
ctre (3.10.0+ds-1) unstable; urgency=medium

  * New upstream version 3.10.0+ds.
  * d/rules: install arch-indep cmake and pkgconf files into /usr/share.

 -- Shengqi Chen <harry@debian.org>  Thu, 14 Aug 2025 23:17:23 +0800

ctre (3.9.0+ds-3) unstable; urgency=medium

  * d/control: mark Multi-Arch: foreign for libctre-{dev,doc}.

 -- Shengqi Chen <harry@debian.org>  Tue, 11 Mar 2025 20:14:26 +0800

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,8 @@
 	dh $@ --with=sphinxdoc --buildsystem=cmake+ninja --builddir=build
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCTRE_BUILD_TESTS=ON
+	dh_auto_configure -- -DCTRE_BUILD_TESTS=ON \
+		-DCMAKE_INSTALL_LIBDIR=/usr/share # these are all arch-indep files, so do not put them into /usr/lib/$triplet
 
 override_dh_installdocs:
 	dh_installdocs
